/// <reference types="react" />
import type { ListElement, ListProps } from "@react-md/list";
import type { CollapseProps } from "@react-md/transition";
export interface TreeGroupProps extends ListProps, Omit<CollapseProps<ListElement>, "children"> {
}
/**
 * The `TreeGroup` component is used to render a tree item's nested items
 * whenever the `expanded` prop is `true`. It uses the `Collapse` component
 * behind the scenes to animate in-and-out of view and will fully unrender when
 * the `expanded` prop is `false`.
 */
export declare const TreeGroup: import("react").ForwardRefExoticComponent<TreeGroupProps & import("react").RefAttributes<ListElement>>;
