import type { ExpandedIds, TreeItemExpansion } from "./types";
/**
 * A hook that implements the base functionality for expanding different tree
 * items.
 *
 * @param defaultExpandedIds - Either a list of tree item ids to be expanded by
 * default or a function that will return the list of tree item ids to be
 * expanded by default
 * @returns An object containing props that can be passed to the `Tree`
 * component to handle the expansion state within the tree.
 */
export declare function useTreeItemExpansion(defaultExpandedIds: ExpandedIds | (() => ExpandedIds)): TreeItemExpansion;
